Attribute VB_Name = "Functions"
' ChangeBackground 1.0.5 - Copyright (C)2004 Klaus Dahlenburg, INCOMM GmbH
' complete rework of coding affecting all modules. Published under the terms
' and conditions of GNU General Public License Version 2, 1991 or later
'
'
' ***************
' changes
' **************
'

Option Explicit

Private lNlsRc As Long
Private aNlsInserts() As String
'
'VB 's Trim function only trims space characters (" ") from the beginning or the end of a string.
'This alternative trims all nonprinting characters (tabs, character returns, etc.)
'This Function ist from: www.codetoad.com
Public Function TrimComplete(ByVal sValue As String) As String

        Dim sAns As String
        Dim sWkg As String
        Dim sChar As String
        Dim lLen As Long
        Dim lCtr As Long

        sAns = sValue
        lLen = Len(sValue)

        If lLen > 0 Then
            'Ltrim
            For lCtr = 1 To lLen
                sChar = Mid(sAns, lCtr, 1)
                If Asc(sChar) > 32 Then Exit For
            Next

            sAns = Mid(sAns, lCtr)
            lLen = Len(sAns)

            'Rtrim
            If lLen > 0 Then
                For lCtr = lLen To 1 Step -1
                    sChar = Mid(sAns, lCtr, 1)
                    If Asc(sChar) > 32 Then Exit For
                Next
            End If
            sAns = Left$(sAns, lCtr)
        End If

        TrimComplete = sAns

End Function
'
' universal function to check field contents. The passed rule
' governs the extent of checking
'
Function chkFld(sData As String, chkVal As String) As Boolean

Dim tmp As Long
'
' value passed will be checked according to the rule given as chkVal
'
    If chkVal = vbNullString Then   ' no checking; avoids diff. calls
        chkFld = True
        Exit Function
    End If
    '
    chkFld = False
    Select Case UCase(chkVal)
        '
        ' "E" = field must not be empty
        '
        Case "E"
            If Trim$(sData) <> vbNullString Then
                chkFld = True
            End If
        '
        ' "N" = numeric, "NP" = numeric and > 0, "NPZ" = numeric >=0
        '
        Case "N", "NP", "NPZ"
            If IsNumeric(sData) Then
                If (CSng(sData) > 0 And chkVal = "NP") Then
                    chkFld = True
                Else
                    If (CSng(sData) >= 0 And chkVal = "NPZ") Then
                        chkFld = True
                    Else
                        If (chkVal = "N") Then
                            chkFld = True
                        End If
                    End If
               End If
            End If
        '
        ' "NI" = integer, "NPI" = integer and > 0, "NPZI" = integer and >=0
        '
        Case "NI", "NPI", "NPZI"
            If IsNumeric(sData) Then
                tmp = CLng(sData)
                If CDbl(sData) = tmp Then
                    If (tmp > 0 And chkVal = "NPI") Then
                        chkFld = True
                    Else
                        If (tmp >= 0 And chkVal = "NPZI") Then
                            chkFld = True
                        Else
                            If (chkVal = "NI") Then
                               chkFld = True
                            End If
                        End If
                    End If
                End If
            End If
        '
        ' unknown function code
        '
        Case Else
            ' normally it's an invalid call but ...
            ' treat field as valid
            chkFld = True
    End Select
    
End Function
