VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMakeBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Copyright (C)2004 Klaus Dahlenburg, INCOMM GmbH
' complete rework of coding affecting all modules. Published under the terms
' and conditions of GNU General Public License Version 2, 1991 or later
'

'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
'even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License along with this program; if not,
'write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
'
'Auf Deutsch (ohen Garantie fr die bersetzung)
'Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License,
'wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem
'Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version.

'Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber
'OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR
'EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.

'Sie sollten eine Kopie der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls
'nicht, schreiben Sie an die Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

'=========================
'
' Diese Klasse enthaelt Methoden zum setzten von Text in Textboxen. Die
' entsprechende Box muss bereits vorhanden sein.
'   setTextBox      - setzt einen einzeiligen Text in ein Textbox, der
'                     automatische Zeilenumbruch ist dabei aktiviert
'   setStringBox    - setzt einen einzeiligen Text in ein Textbox, der
'                     automatische Zeilenumbruch ist dabei deaktiviert
'   setDblTextBox   - setzt zweizeiligen Text. Die beiden Texteinheiten
'                     werden durch vbLf getrent und somit direkt unter
'                     einander gesetzt. vbNewLine ergaebe eine Leerzeile
'                     Sollte dies nicht immer zum gewuenschten Ergebnis
'                     fuehren, muss der Text mittels setTwoInOneBox()
'                     gesetzt werden
'   setTwoInOneBox  - setzt zweizeiligen Text. Die beiden Texteinheiten
'                     werden in zwei separaten Boxen gesetzt, die mit
'                     halber Zeilenhoehe direkt untereinander gesetzt
'                     werden. Die beiden Textboxen werden automatisch
'                     erzeugt. Die umgebende Box muss vorhanden sein
'   setVertBoxes    - setzt eine oder mehrere Boxen mit identischem Aufbau
'                     direkt untereinander. Die Startbox muss vorhanden sein
'   setHortBoxes    - setzt eine oder mehrere Boxen mit identischem Aufbau
'                     direkt nebeneinander. Die Startbox muss vorhanden sein
'
' **************************************************************************
'
' ***********************
'
' changes
'
' ***********************
'
Option Explicit
'
'
' used by textedit
Private bSlant As Boolean
Private bPStyle As Boolean
Private bWithBorder As Boolean
Private lTColor As Long
Private sFontName As String
Private dFontSize As Double
Private dFontSizeSmall As Double
Private dZellHoehe As Double
'
Private sFehler As String
Private objTextBox As SolidEdgeFrameworkSupport.TextBox
'
' used for attribute set creation
Private sAttrSetName As String
Private sAttrItemName  As String
Private sAttrBoxItemValue  As String
Private sFormatVorlage  As String

'
' Einfuegen von 1 TextZeile in eine Textbox
' - wird als BoxType gesetzt also mit Zeilenumbruch gesetzt
' Setzen Schriftart, -groesse, und Rahmen
Public Sub setTextBox(pTextBoxes As SolidEdgeFrameworkSupport.TextBoxes, _
            pText As String, _
            Optional pBoxItemVal As String = vbNullString, _
            Optional pUline As Boolean = False)
'
Set objTextBox = pTextBoxes.Item(pTextBoxes.Count)
'
    With objTextBox
        .Edit.Name = sFormatVorlage
        .Edit.Color = lTColor
        .Edit.Font = sFontName
        .Edit.Bold = bPStyle       ' either true = bold or false = normal dah-2
        .Edit.Italic = bSlant       ' true = italic
        .Edit.Underline = pUline     ' true = underline Text
        .Edit.HorizontalAlignment = igTextHzAlignCenter
        .Edit.TextSize = dFontSize              ' as set by caller
        .PlacementType = igTextBoxType
        .Text = pText
        .VerticalAlignment = igTextHzAlignVCenter
        '
        If bWithBorder Then
            .BorderType = igTextBorderRectangle
        Else
            .BorderType = igTextBorderNone
        End If
        .height = dZellHoehe
        '
        ' wenn nicht leer neues AttributeSet mit dem entsprechenden Namen
        If sAttrSetName <> vbNullString Then
            .AttributeSets.Add CStr(sAttrSetName)
            With .AttributeSets.Item(1)
                .Add CStr(sAttrItemName), seStringANSI
                .Item(1) = CStr(pBoxItemVal)     ' insert that what is passed to us
            End With
        End If
    End With
End Sub
'
' Einfuegen von 2 TextZeilen in eine Textbox
' - wird als BoxType gesetzt also mit Zeilenumbruch gesetzt
' Setzen Schriftart, -groesse, und Rahmen
' Note:
'   experimental; to avoid to have to set two small textboxes
'   box height: full height, fontsize: normal size * 0.714
'
Public Sub setDblTextBox(pTextBoxes As SolidEdgeFrameworkSupport.TextBoxes, _
            pTextOben As String, _
            pTextUnten As String, _
            Optional pUline As Boolean = False, _
            Optional pBoxItemVal As String = vbNullString)
'
Set objTextBox = pTextBoxes.Item(pTextBoxes.Count)
'
    With objTextBox
        '
        ' data for Edit
        .Edit.Name = sFormatVorlage
        .Edit.Color = lTColor
        .Edit.Font = sFontName                  ' as set by caller
        .Edit.Bold = bPStyle        ' either true = bold or false = normal dah-2
        .Edit.Italic = bSlant       ' true = italic
        .Edit.Underline = pUline     ' true = underline Text
        .Edit.TextSize = dFontSize              ' as set by caller
        .Edit.HorizontalAlignment = igTextHzAlignCenter
        '
        ' data for the text box
        .PlacementType = igTextBoxType
        .Text = pTextOben & vbLf & pTextUnten
        .VerticalAlignment = igTextHzAlignVCenter
        '
        If bWithBorder Then
            .BorderType = igTextBorderRectangle
        End If
        .height = dZellHoehe                     ' as set by caller
        '
        ' wenn nicht leer neues AttributeSet mit dem entsprechenden Namen
        If sAttrSetName <> vbNullString Then
            .AttributeSets.Add CStr(sAttrSetName)
            With .AttributeSets.Item(1)
                .Add CStr(sAttrItemName), seStringANSI
                .Item(1) = CStr(pBoxItemVal)     ' insert that what is passed to us
            End With
        End If
    End With
        '
End Sub
'
' Einfuegen von 2 TextBoxen in eine Textbox
' - wird als BoxType gesetzt also mit Zeilenumbruch gesetzt
' Setzen Schriftart, -groesse, und Rahmen
' Note:
'   box already set with height: full height, fontsize: normal size * 0.714
'
Public Sub setTwoInOneBox(pTextBoxes As SolidEdgeFrameworkSupport.TextBoxes, _
            pTextOben As String, _
            pTextUnten As String, _
            Optional pBoxItemVal As String = vbNullString, _
            Optional pUnderline As Boolean = False)
            
Static dZHsave As Double
Static Lx As Double
Static Ly As Double
Static Ux As Double
Static Uy As Double
Static dHeight As Double
'
    Set objTextBox = pTextBoxes.Item(pTextBoxes.Count)
    dHeight = objTextBox.height / 2
    dZHsave = dZellHoehe
    '
    Call setBases(pCellHeight:=dHeight)
    Call objTextBox.Range(Lx, Ly, Ux, Uy)
    '
    ' set upper box
    Ly = Ly + dHeight
    Call pTextBoxes.AddByTwoPoints(Lx, Ly, 0, Ux, Uy, 0)
    Call setTextBox(pTextBoxes:=pTextBoxes, _
                        pText:=pTextOben, _
                        pUline:=pUnderline, _
                        pBoxItemVal:=pBoxItemVal)
    '
    ' set lower box
    dHeight = objTextBox.height
    Ly = Ly - dHeight
    Uy = Uy - dHeight
    Call pTextBoxes.AddByTwoPoints(Lx, Ly, 0, Ux, Uy, 0)
    Call setTextBox(pTextBoxes:=pTextBoxes, _
                        pText:=pTextUnten, _
                        pUline:=pUnderline, _
                        pBoxItemVal:=pBoxItemVal)
    '
    ' restore cell height
    Call setBases(pCellHeight:=dZHsave)
    '
End Sub
'
' Einfuegen von n TextBoxen vertikal ueber- oder untereinander
' - wird als BoxType gesetzt also mit Zeilenumbruch gesetzt
' Setzen Schriftart, -groesse, und Rahmen
'
Public Function setVertBox(pTextBoxes As SolidEdgeFrameworkSupport.TextBoxes, _
            pText() As String, _
            Optional pBoxItemVal As String = vbNullString, _
            Optional ByVal pCounter As Long = 1, _
            Optional pStringBox As Boolean = False, _
            Optional pUnderline As Boolean = False, _
            Optional ByVal pOffset As Single = 0) As Double()
'
Static Lx As Double
Static Ly As Double
Static Ux As Double
Static Uy As Double
Static i As Long
Static dInter As Double
Static dShift As Double
Static Lxs As Double
Static Uxs As Double
Static lLeft As Long
Static dCoord() As Double
'
    ReDim dCoord(0, 0)
    If pCounter = 0 Then
        setVertBox = dCoord()
        Exit Function
    End If
    '
    ' check horizontal shift
    If pOffset > 1 Or pOffset < -1 Then
        setVertBox = dCoord()
        Exit Function
    ElseIf pStringBox Then
            pOffset = 0               ' not supported with this type
    End If
    '
    ' negative counter box on downside
    lLeft = 1
    If pCounter < 0 Then
        pCounter = Abs(pCounter)
        lLeft = -1
    End If
    '
    ' check passed Textarray
    If UBound(pText) <> pCounter - 1 Then
        setVertBox = dCoord()
        Exit Function
    End If
    '
    Set objTextBox = pTextBoxes.Item(pTextBoxes.Count)
    ReDim dCoord(pCounter - 1, 3)
    '
    For i = 1 To pCounter
        If pStringBox Then
            Call setStringBox(pTextBoxes:=pTextBoxes, _
                        pText:=CStr(pText(i - 1, 0)), _
                        pUline:=pUnderline, _
                        pBoxItemVal:=pBoxItemVal)
        Else
            Call setTextBox(pTextBoxes:=pTextBoxes, _
                        pText:=CStr(pText(i - 1, 0)), _
                        pUline:=pUnderline, _
                        pBoxItemVal:=pBoxItemVal)
        End If
        Call objTextBox.Range(Lx, Ly, Ux, Uy)
        dCoord(i - 1, 0) = Lx
        dCoord(i - 1, 1) = Ly
        dCoord(i - 1, 2) = Ux
        dCoord(i - 1, 3) = Uy
        If i < pCounter Then
            '
            ' calculate vertical Y-offset (+/- height of cell)
            dInter = objTextBox.height * lLeft
            Uy = Uy + dInter
            Ly = Ly + dInter
            '
            ' calculate horizontal offset (-cellwidth -- 0 -- +cellwidth)
            ' this will determine the direction left or right
            '
            ' for variable boxes <= 0 means justify left
            ' all other values mean justify right. The width of the
            ' first box is determined by the textbox already set
            ' String boxes will be set always flush left
            If pText(i, 1) <> vbNullString And Not pStringBox Then
                dInter = CDbl(Val(pText(i, 1)))
                If pOffset <= 0 Then
                    Ux = Lx + dInter
                Else
                    Lx = Ux - dInter
                End If
            Else
                dInter = objTextBox.width * pOffset
                Lx = Lx + dInter
                Ux = Ux + dInter
            End If
            Call pTextBoxes.AddByTwoPoints(Lx, Ly, 0, Ux, Uy, 0)
            Set objTextBox = pTextBoxes.Item(pTextBoxes.Count)
       End If
    Next i
    '
    setVertBox = dCoord()
    '
End Function
'
' Einfuegen von n TextBoxen horizontal rechts oder links nebeneinander
' - wird als BoxType gesetzt also mit Zeilenumbruch gesetzt
' Setzen Schriftart, -groesse, und Rahmen
'
Public Function setHortBox(pTextBoxes As SolidEdgeFrameworkSupport.TextBoxes, _
            pText() As String, _
            Optional pStringBox As Boolean = False, _
            Optional pBoxItemVal As String = vbNullString, _
            Optional ByVal pCounter As Long = 1, _
            Optional pUnderline As Boolean = False, _
            Optional ByVal pOffset As Single = 0)
'
Static Lx As Double
Static Ly As Double
Static Ux As Double
Static Uy As Double
Static Lxs As Double
Static Uxs As Double
Static i As Long
Static dInter As Double
Static dShift As Double
Static lLeft As Long
Static dCoord() As Double
'
    ReDim dCoord(0, 0)
    pStringBox = True
    If pCounter = 0 Then
        setHortBox = dCoord()
        Exit Function
    End If
    '
    ' check vertical shift
    If pOffset > 1 Or pOffset < -1 Then
        setHortBox = dCoord()
        Exit Function
    End If
    '
    ' negative counter: box on leftside
    lLeft = 1
    If pCounter < 0 Then
        pCounter = Abs(pCounter)
        lLeft = -1
    End If
    '
    Set objTextBox = pTextBoxes.Item(pTextBoxes.Count)
    ReDim dCoord(pCounter - 1, 3)
    '
    For i = 1 To pCounter
        If i > 1 Then
            If pText(i - 1, 1) <> vbNullString Then
                dInter = CDbl(Val(pText(i - 1, 1)))
                '
                ' left or right ?
                If lLeft < 1 Then
                    Ux = Lx
                    Lx = Lx - dInter
                Else
                    Lx = Ux
                    Ux = Lx + dInter
                End If
            Else
                Ux = Ux + dInter
                Lx = Lx + dInter
            End If
            Call pTextBoxes.AddByTwoPoints(Lx, Ly, 0, Ux, Uy, 0)
        End If
        '
        Set objTextBox = pTextBoxes.Item(pTextBoxes.Count)
        Call setTextBox(pTextBoxes:=pTextBoxes, _
                    pText:=CStr(pText(i - 1, 0)), _
                    pUline:=pUnderline, _
                    pBoxItemVal:=pBoxItemVal)
        Call objTextBox.Range(Lx, Ly, Ux, Uy)
        dCoord(i - 1, 0) = Lx
        dCoord(i - 1, 1) = Ly
        dCoord(i - 1, 2) = Ux
        dCoord(i - 1, 3) = Uy
        If i < pCounter Then
            '
            ' calculate vertical offset (-cellheight -- 0 -- +cellheight)
            dInter = (Uy - Ly) * pOffset
            Uy = Uy + dInter
            Ly = Ly + dInter
            '
            ' set horizontal X-offset (+/- width of cell)
            dInter = (Ux - Lx) * lLeft
        End If
    Next i
    '
    setHortBox = dCoord()
    '
End Function

' Einfuegen von 1 TextZeile in eine String(Text)box
' - wird als StringType ohne Zeilenumbruch gesetzt
' Setzen Schriftart, -groesse, und Rahmen
'
Public Sub setStringBox(pTextBoxes As SolidEdgeFrameworkSupport.TextBoxes, _
            pText As String, _
            Optional pBoxItemVal As String = " ", _
            Optional pUline As Boolean = False)
'
Set objTextBox = pTextBoxes.Item(pTextBoxes.Count)
'
    With objTextBox
        .Edit.Name = sFormatVorlage
        .Edit.Color = lTColor
        .Edit.Font = sFontName
        .Edit.Bold = bPStyle       ' either true = bold or false = normal dah-2
        .Edit.Italic = bSlant       ' true = italic
        .Edit.Underline = pUline     ' true = underline Text
        .Edit.TextSize = dFontSize
        .Edit.HorizontalAlignment = igTextHzAlignLeft
        '
        If bWithBorder Then
            .BorderType = igTextBorderRectangle
        End If
        .height = dZellHoehe
        '
        .PlacementType = igTextStringType
        .Text = pText
        .VerticalAlignment = igTextHzAlignVCenter
        '
        '
        ' wenn nicht leer neues AttributeSet mit dem entsprechenden Namen
        If sAttrSetName <> vbNullString Then
            .AttributeSets.Add CStr(sAttrSetName)
            With .AttributeSets.Item(1)
                .Add CStr(sAttrItemName), seStringANSI
                .Item(1) = CStr(pBoxItemVal)     ' insert that what is passed to us
            End With
        End If
    End With
    '
End Sub
'
Public Function centerBox(pTextBoxes As SolidEdgeFrameworkSupport.TextBoxes, _
                      ByVal pXcoord As Double, _
                      ByVal pYcoord As Double, _
                      pWidth As Double, _
                      pHeight As Double) As Double()
'
Static Lx As Double
Static Ly As Double
Static Ux As Double
Static Uy As Double
Static width As Double
Static height As Double
Static dRetVal() As Double
'
    Set objTextBox = pTextBoxes.Item(pTextBoxes.Count)
    ReDim dRetVal(0, 0)
'
    With objTextBox
        Call objTextBox.Range(Lx, Ly, Ux, Uy)
        width = (Ux - Lx) / 2
        height = (Uy - Ly) / 2
        '
        ' either field 0 will break move()
        If Not (width = 0 Or height = 0) Then
            pYcoord = pYcoord + (pHeight / 2) - height
            pXcoord = pXcoord + (pWidth / 2) - width
            Call objTextBox.Move(Lx, Ly, pXcoord, pYcoord)
            ReDim dRetVal(0, 3)
            Call objTextBox.Range(dRetVal(0, 0), dRetVal(0, 1), dRetVal(0, 2), dRetVal(0, 3))
        End If
        centerBox = dRetVal()
    End With
'
End Function

Public Sub setBases(Optional pFSize As Double = 0, _
                    Optional pFname As String = vbNullString, _
                    Optional pCellHeight As Double = 0, _
                    Optional pItalic As Long = -1, _
                    Optional pPrtStyle As Long = -1, _
                    Optional pBorder As Long = -1, _
                    Optional pTextColor As Long = -1)
    
    sFontName = IIf(pFname <> vbNullString, pFname, sFontName)
    dFontSize = IIf(pFSize > 0, pFSize, dFontSize)
    dZellHoehe = IIf(pCellHeight > 0, pCellHeight, dZellHoehe)
    lTColor = IIf(pTextColor >= 0, pTextColor, lTColor)
    If pItalic >= 0 Then
        bSlant = pItalic > 0
    End If
    If pPrtStyle >= 0 Then
        bPStyle = pPrtStyle > 0
    End If
    If pBorder >= 0 Then
        bWithBorder = pBorder > 0
    End If
   '
End Sub
Public Sub setAttrSetData(sSetName As String, _
                         sItemName As String, _
                         sItemValue As String, _
                         sFormatV As String)
    sAttrSetName = sSetName
    sAttrItemName = sItemName
    sAttrBoxItemValue = sItemValue
    sFormatVorlage = sFormatV
    '
End Sub
'
' return error text
'
Public Function getError() As String
    getError = sFehler
End Function
'
' get the current text box item value setting
'
Public Property Get getBoxItemValue() As String
    getBoxItemValue = sAttrBoxItemValue
End Property

Private Sub class_Initialize()
    '
    sFehler = vbNullString
    sAttrSetName = vbNullString
    sAttrItemName = vbNullString
    sAttrBoxItemValue = vbNullString
    sFormatVorlage = vbNullString
    '
    sFontName = "Arial"
    dFontSize = 0.0035
    dZellHoehe = 0.009
    bSlant = False
    bPStyle = False
    bWithBorder = True
    lTColor = 0
    '
    Set objTextBox = Nothing
    '
End Sub

Private Sub Class_Terminate()
    sFehler = vbNullString
    Set objTextBox = Nothing
End Sub

